/***
 * oオɈڂĂ
 *
 * Copyright(C) 2005 NSP. All rights reserved.
 *
 */

using System;
using System.Net;
using System.IO;
using System.Text;
using System.Threading;
using System.Text.RegularExpressions;
using System.Windows.Forms;
using System.Drawing;
using System.Collections;
using System.Drawing.Drawing2D;




namespace SaimoeCounter {
	// LύX̒ʒm
	public delegate void NumOfCharaHandler(int numOfChara); 
	// VL̒ʒm
	public delegate void NewCharaHandler(string newChara); 
	// num Ԗڂ̃{bNXL chara I
	public delegate void SelectCharaHandler(string chara, int num); 
	/**
	 * OI{bNX
	 * VLǉCxg NewCharaAdded
	 * LύXCxg NumOfCharaChanged
	 * LIύXCxg SelectCharaChanged
	 * Ȃǂ𔭍s
	 * VL͍ꂽƂɂ͂ICʒm
	 */
	class NameComboBoxPanel : Panel{
		public event NumOfCharaHandler NumOfCharaChanged;
		public event NewCharaHandler NewCharaAdded;
		public event SelectCharaHandler SelectCharaChanged;
			
		const int boxh = 22;        // {bNX̏c
		const int boxw = 115;       // {bNX̕
		const int strw = 7;        // ꕶ̂̕
		const int hStep = 4;        // c̊Ԋu
		const int wStep = 4;        // ̊Ԋu
		const int numPerRow = 5;    // s̐
		const int labelOffh = 4;    // x̏㉺ItZbg
		// combo[0] ͏ɑ݂C\ꂸɍڂێ̂
		ComboBox [] combos;         // {bNX
		Label [] labels;            // Ή郉x
		Button buttonCharaNum;
		TextBox textCharaNum;
		const string NEW_CHARA = "-- New Chara --";
		EventHandler charaSelectionChangedHandler;
		public NameComboBoxPanel(int n){
			combos = null;
			textCharaNum = new TextBox();
			textCharaNum.Text = " "+n;
			buttonCharaNum = new Button();
			buttonCharaNum.Text = "Change #Chara";
			buttonCharaNum.Click += new EventHandler(CharaNumClick_Handler);
			this.Controls.Add(buttonCharaNum);
			this.Controls.Add(textCharaNum);
			textCharaNum.KeyPress += new KeyPressEventHandler(KeyPress_Handler);

			charaSelectionChangedHandler = new EventHandler(CharaSelectionChanged_Handler);
			// ݒ肵ăCAEg
			this.CharaNum = n;
		}
		// ZNgς
		void CharaSelectionChanged_Handler(object src, EventArgs e){
			int idx = 0;
			for(idx = 1; idx < combos.Length; idx++){
				if(src==combos[idx]) break;
			}
			string name = (string)combos[idx].SelectedItem;
			if(name==NEW_CHARA){ // VL
				// _CAO{bNXŎ荞
				TextBoxDialog textDialog = new TextBoxDialog("New Character Name?");
				name = textDialog.inputText();
				textDialog.Dispose();
				// 󔒂ƂȂ
				if(name!=null) {
					name = name.Trim();
					if(name.Equals("")){
						name = null;
					}
				}
				if(name!=null){
					// L̒ǉʒm
					if(NewCharaAdded!=null) NewCharaAdded(name);
				} else {
				}
				// V̂ID
				combos[idx].SelectedItem = name;
			}
			// L̕ύXʒm
			if(SelectCharaChanged!=null)SelectCharaChanged(name, idx);
		}
		// L[͂⑫. ENter L[Ȃ{^̂Ɠ
		void KeyPress_Handler(object src, KeyPressEventArgs e){
			if(e.KeyChar == (char)0x0d) {
				e.Handled = true;
				CharaNumClick_Handler(null, null);
			}
		}
		// {^琔ύX
		void CharaNumClick_Handler(object src, EventArgs e){
			string str = textCharaNum.Text.Trim();
			try {
				int n = int.Parse(str);
				this.CharaNum = n;
					
			} catch(Exception ex){
				Console.WriteLine(ex.Message);
				Console.WriteLine(ex.StackTrace);
			}
		}
		public int CharaNum {
			get { return combos.Length; }
			set { doLayout(value); }
		}
		void doLayout(int n){
			SuspendLayout();
			if(n < 1 || n > 100) return;
			if(combos != null && combos.Length == (n+1)) return;
			ComboBox dummy;
			int m = 0;
			if(combos !=null){
				m = combos.Length - 1;
				if(m > n){
					for(int i = n; i <= m; i++){
						this.Controls.Remove(combos[i]);
						this.Controls.Remove(labels[i]);
					}
					m = n;
				}
				dummy = combos[0];
			} else {
				dummy = new ComboBox();
				dummy.Items.Add(NEW_CHARA);
			}
			object [] objs = new object[dummy.Items.Count];
			int idx = 0;
			foreach(object obj in dummy.Items){
				objs[idx++] = obj;
			}
				
			ComboBox [] oldcombos = combos;
			Label [] oldlabels = labels;
			combos = new ComboBox[n+1];
			labels = new Label[n+1];
			combos[0] = dummy;
				
			int x = 0;
			int y = 0;

			int k, l;
			for(k = 0, l = n; l > 0; k++, l/=10);
			string [] spaces = new string[k+1];
			string ss = "";
			for(int i = k-1; i >= 0; i--){
				spaces[i] = ss;
				ss += " ";
			}
			Size size  = new Size(boxw, boxh);
			Size lsize  = new Size((int)((k+1)*strw), boxh);

			for(int i = 1; i <= n; i++){
				if(i <= m){
					combos[i] = oldcombos[i];
					labels[i] = oldlabels[i];
				} else {
					labels[i] = new Label();
					combos[i] = new ComboBox();
					combos[i].SelectedIndexChanged+= charaSelectionChangedHandler;

					combos[i].Items.AddRange(objs);
				}
				string str = ""+i;
				str = spaces[str.Length-1] + str;
				str = str + ".";
				labels[i].Text = str;
				labels[i].Size = lsize;
				labels[i].Location = new Point(x, y+labelOffh);
				combos[i].Size = size;
				combos[i].Location = new Point(x + lsize.Width, y);
				this.Controls.Add(labels[i]);
				this.Controls.Add(combos[i]);
				x+=size.Width + lsize.Width+wStep;
				if((i%numPerRow)==0){
					y+=size.Height + hStep;
					x = 0;
				}
			}
			int sep = 2;
			int sep2 = lsize.Width/3;
			int ww = size.Width + lsize.Width - sep2;
			Size bsize = new Size(ww*3/4, size.Height);
			Size tsize = new Size(ww-bsize.Width-sep, size.Height);
			buttonCharaNum.Size = bsize;
			buttonCharaNum.Location = new Point(sep2+x , y);
			textCharaNum.Size = tsize;
			textCharaNum.Location = new Point(x+sep2+ bsize.Width + sep, y+2);
			x = (n+1 < numPerRow) ? n+1 : numPerRow;
			x = x * (size.Width + lsize.Width + wStep) - wStep;
			y = (n) / numPerRow + 1;
			y = y * (size.Height + hStep) - hStep;
			this.Size = new Size(x, y);
			ResumeLayout();
			//L̕ύXʒm
			if(NumOfCharaChanged!=null) NumOfCharaChanged(n);
		}
		// IACe̎擾
		public string [] getSelectedNames(){
			string [] names = new string[combos.Length];
			for(int i = 0; i < names.Length; i++){
				names[i] = (string)combos[i].SelectedItem;
			}
			return names;
		}
		// IACe̐ݒ
		public void setSelectedNames(string [] names){
			int m = combos.Length;
			if(names.Length < combos.Length) m = names.Length;
			for(int i = 0; i < m; i++){
				combos[i].SelectedItem = names[i];
			}
		}
		public void AddCharaName(string name){
			for(int i = 0; i < combos.Length; i++){
				combos[i].Items.Insert(0, name);
			}
		}
	}
	/**
	 * eZbeBOp̃pl
	 * x[XURL, XbhԍCLC͊JnȂ
	 * LIȂǂ̃Cxg NameComboBoxPanel ̕Ŏ󂯎
	 */
	class SettingPanel : Panel {
		private SaimoeCounter scounter;    
		private NameComboBoxPanel combos;  // OĨR{{bNX
		private GroupBox groupCombo;       // O[v
		private Label labelFetch;          // x
		private Label labelUnFetch;
		private Label labelBase;
		private Label labelResult;
		private Label labelDate;
		private TextBox textBase;          // Xbh̃x[X URL
		private TextBox textFetch;         // ƂĂXbh
		private TextBox textUnFetch;       // [J̃t@C̃Xbh
		private TextBox textResult;        // ʕ\
		private ListBox threnumHist;       // XԗH
		private Button buttonAnalyze;      // ̓{^
		private DateTimePicker dateTimePicker; // t

		private HistoryDDControlListBox hddlist;  // qXg[֌WD&Dp
		private HistoryDDControlText hddtextF;
		private HistoryDDControlText hddtextU;
		private DragDropManager ddmanagerL, ddmanagerF, ddmanagerU;
		
		private int minHeight;   // ŏ̕Kvȍ

		// qXg[ D&D ̃f[^(Xbhԍ̔z)
		class HistoryDDItem {
			public string [] thres;
			public HistoryDDItem(string [] ss){
				thres = ss;
			}
		}
		// TextBox Ɏ󂯎̂
		class HistoryDDControlText : IDragDropControl {
			TextBox text;
			public HistoryDDControlText(TextBox text){
				this.text = text;
			}
			// \Ȍ^
			public string AcceptableType { get {return (typeof(HistoryDDItem)).ToString();} }
			// D&DRg[
			public Control Control{ get {return this.text;} }
			// 鑀
			public DragDropEffects AllowedEffects{ get{ return DragDropEffects.All;} }
			// ACe󂯎Ƃ
			public void CatchItem(object obj, DragEventArgs e){
				HistoryDDItem dditem = obj as HistoryDDItem;
				if(dditem == null) return;
				if((e.Effect & DragDropEffects.Move) == DragDropEffects.Move
				   || (e.Effect & DragDropEffects.Copy) == DragDropEffects.Copy){
					// Sɒǉ
					string [] thres = dditem.thres;
					for(int i = 0; i < thres.Length; i++){
						text.AppendText(" " + thres[i]);
					}
				}		
			}
			// ACeɗƂ
			public void DragItemDropped(object data, DragDropEffects e){
				// ɉȂ
			}
			// f[^î͖j
			public object GenDragData(){
				return null;
			}
		}
		class HistoryDDControlListBox : IDragDropControl {
			ListBox list;
			public HistoryDDControlListBox(ListBox list){
				this.list = list;
			}
			// \Ȍ^
			public string AcceptableType { get {return (typeof(HistoryDDItem)).ToString();} }
			// D&DRg[
			public Control Control{ get {return this.list;} }
			// 鑀
			public DragDropEffects AllowedEffects{ get{ return DragDropEffects.All;} }
			// ACe󂯎Ƃ
			public void CatchItem(object obj, DragEventArgs e){
				// Ȃ
			}
			// ACeɗƂ
			public void DragItemDropped(object data, DragDropEffects e){
				// ɉȂ
			}
			// f[^iI𒆂̃ACepbNj
			public object GenDragData(){
				ArrayList al = new ArrayList();
				for(int i = 0; i < list.Items.Count; i++){
					if(list.GetSelected(i)) al.Add(list.Items[i]);;
				}
				string [] thres = new string[al.Count];
				int idx = 0;
				foreach(object obj in al){
					thres[idx++] = (string)obj;
				}
				return new HistoryDDItem(thres);;
			}
		}
		//StringBuilder resultString = new StringBuilder("");
		//string resultString = "";
		// rʏo͗p
		public void PrintProgressReset(){
			 this.textResult.Text = "";
			 //resultString = "";
		}
		
		// rʏo͗p
		public void PrintProgress(string str){
			this.textResult.AppendText(str);
// 			resultString += str;
//  			this.textResult.Lines = splitString(resultString);
// 			this.textResult.ScrollToCaret();
		}
		string [] splitString(string str){
			return str.Split('\n');
		}
		public string ResultText {
			get {return this.textResult.Text; }
			set {this.textResult.Text = value; }
		}
		// tԂ
		public DateTime Date {
			get {return this.dateTimePicker.Value;}
		}
		// KvȍԂ
		public int MinHeight {
			get {return this.minHeight;}
		}
		// LZNĝԂ
		public NameComboBoxPanel CharaSelector {
			get {return this.combos;}
		}
		// URL Ԃ
		public string URL{
			get {return textBase.Text; }
			set {textBase.Text = value; }
		}
		// ƂĂ XbhԍԂ
		public string [] getFetchThreads(){
			string str = textFetch.Text;
			string [] thres = SplitThreadNumbers(str);
			UpdateHistory(thres);
			return thres;
		}
		// [ĴgXbhԍ
		public string [] getUnFetchThreads(){
			string str = textUnFetch.Text;
			string [] thres = SplitThreadNumbers(str);
			UpdateHistory(thres);
			return thres;
		}
		// qXg̃Abvf[g(\[ĝŖʓ|)
		void UpdateHistory(string [] thres){
			ArrayList al = new ArrayList();
			for(int i = 0; i < thres.Length; i++){
				if(!threnumHist.Items.Contains(thres[i])){
					al.Add(thres[i]);
				}
			}
			string [] nt = new string[al.Count + threnumHist.Items.Count];
			int idx = 0;
			foreach(object obj in threnumHist.Items){
				nt[idx++] = (string)obj;
			}
			foreach(object obj in al){
				nt[idx++] = (string)obj;
			}
			Array.Sort(nt);
			threnumHist.BeginUpdate();
			threnumHist.Items.Clear();
			for(int i = nt.Length -1; i >= 0; i--){
				threnumHist.Items.Add(nt[i]);
			}
			threnumHist.EndUpdate();
		}
		// qXg̐ݒiʏSaimoeCounter ŏɃt@Cǂݍ񂾎Ɂj
		public void setHistory(string [] hist){
			threnumHist.Items.Clear();
			UpdateHistory(hist);
			//for(int i = 0; i < hist.Length; i++){
			//}
		}
		// qXg̎擾iʏSaimoeCounter ŌɃt@CގɁj
		public string [] getHistory(){
			string [] hist = new string[threnumHist.Items.Count];
			int idx = 0;
			foreach(object item in threnumHist.Items){
				hist[idx++] = (string)item;
			}
			return hist;
		}
		// 񂩂Xbhԍ؂o
		// Ƃɂ\̘̐A珇
		string [] SplitThreadNumbers(string str){
			Regex r = new Regex("[0-9]{10}");
			MatchCollection mc = r.Matches(str);
			string [] thnums = new string [mc.Count];
			for (int i = 0; i < mc.Count; i++) {
				thnums[i] = mc[i].Value;
			}
			return thnums;
		}
		// RXgN^
		public SettingPanel(SaimoeCounter scounter){
			this.scounter = scounter;
			createSettngPanel();
		}
		// 
		void createSettngPanel(){
			int numCombo = scounter.NumButtleChara;
			combos = new NameComboBoxPanel(numCombo);
			groupCombo = new GroupBox();
			labelFetch = new Label();
			labelUnFetch = new Label();
			labelBase = new Label();
			labelResult = new Label();
			labelDate = new Label();
			textBase = new TextBox();
			textFetch = new TextBox();
			textUnFetch = new TextBox();
			textResult = new TextBox();
			threnumHist = new ListBox();
			buttonAnalyze = new Button();
			dateTimePicker = new DateTimePicker();
			
			labelFetch.Text = "Threads (Fetch) :";
			labelUnFetch.Text = "Threads (Local) :";
			labelBase.Text = "Base URL :";
			labelResult.Text = "Result :";
			labelDate.Text = "Date :";
			textBase.Text = "http://jbbs.livedoor.jp/bbs/read.cgi/game/20311/";
			buttonAnalyze.Text = "Analyze";
			groupCombo.Text = "Characters";

			textResult.Multiline = true;
			textResult.ScrollBars = ScrollBars.Vertical;
			
			groupCombo.Controls.Add(combos);
			this.Controls.Add(buttonAnalyze);
			this.Controls.Add(labelFetch);
			this.Controls.Add(labelUnFetch);
			this.Controls.Add(labelBase);
			this.Controls.Add(labelResult);
			this.Controls.Add(labelDate);
			this.Controls.Add(textBase);
			this.Controls.Add(textFetch);
			this.Controls.Add(textUnFetch);
			this.Controls.Add(textResult);
			this.Controls.Add(dateTimePicker);
			this.Controls.Add(threnumHist);
			this.Controls.Add(groupCombo);
			combos.SizeChanged += new EventHandler(CombosSizeChanged_Hander);
			buttonAnalyze.Click += new EventHandler(ButtonAnalyze_Click);

			threnumHist.MultiColumn = true;
			threnumHist.HorizontalScrollbar = true;
			// Shift ȂIƂɁCʏ̕\ƑIقȂ
			// Ȃ킩D
			//threnumHist.SelectionMode = SelectionMode.MultiExtended;
			threnumHist.SelectionMode = SelectionMode.MultiSimple;
			threnumHist.ColumnWidth = 70;
			threnumHist.Sorted = false;
			textFetch.AllowDrop = true;
			textUnFetch.AllowDrop = true;
			hddlist = new HistoryDDControlListBox(threnumHist);
			hddtextF = new HistoryDDControlText(textFetch);
			hddtextU = new HistoryDDControlText(textUnFetch);
			ddmanagerL = new DragDropManager(hddlist);
			ddmanagerF = new DragDropManager(hddtextF);
			ddmanagerU = new DragDropManager(hddtextU);
			
			doLayout();
		}
		// combo ̃TCYς烌CAEg蒼
		// {͈ꕔł̂Cʓ|Ȃ̂őS
		void CombosSizeChanged_Hander(object src, EventArgs e){
			doLayout();
		}
		// ͊Jn
		void ButtonAnalyze_Click(object src, EventArgs e){
			scounter.doAnalyze();
		}
		// zu
		void doLayout(){
			SuspendLayout();
			const int h = 22;
			const int resulth = 30;//42;
			const int histh = h*3;
			const int labelw = 100;
			const int datelabelw = 40;
			const int buttonw = 100;
			const int textboxw = 480;
			const int resultw = 650;
			const int datew = 200;
			const int histw = 150;
			const int leftmost = 10;
			const int top = 10;
			const int hstep = 4;
			const int buttonLeft = leftmost;
			const int labelLeft = leftmost;
			const int grpLeft = leftmost;
			const int boxLeft = labelLeft + labelw;
			const int dateLabelLeft = buttonLeft + buttonw + 20;
			const int dateLeft = dateLabelLeft + datelabelw;
			const int histLeft = boxLeft + textboxw + 20;
			const int labelOffh = 4;
			
			Size labelSize = new Size(labelw, h);
			Size textboxSize = new Size(textboxw, h);
			buttonAnalyze.Size = new Size(buttonw, h);
			labelFetch.Size = labelSize;
			labelUnFetch.Size = labelSize;
			labelBase.Size = labelSize;
			labelResult.Size = labelSize;
			labelDate.Size = new Size(datelabelw, h);
			textBase.Size = textboxSize;
			textFetch.Size = textboxSize;
			textUnFetch.Size = textboxSize;
			textResult.Size = new Size(resultw, resulth);
			dateTimePicker.Size = new Size(datew, h);
			threnumHist.Size = new Size(histw, histh);

			int y = top;

			buttonAnalyze.Location = new Point(buttonLeft, y);
			labelDate.Location = new Point(dateLabelLeft, labelOffh+y);
			dateTimePicker.Location = new Point(dateLeft, y);
			y+=hstep*2 + buttonAnalyze.Height;

			labelBase.Location = new Point(labelLeft, labelOffh+y);
			textBase.Location = new Point(boxLeft, y);
			threnumHist.Location = new Point(histLeft, y);
			y+=hstep  + textBase.Height;;

			labelFetch.Location = new Point(labelLeft, labelOffh+y);
			textFetch.Location = new Point(boxLeft, y);
			y+=hstep + textFetch.Height;

			labelUnFetch.Location = new Point(labelLeft, labelOffh+y);
			textUnFetch.Location = new Point(boxLeft, y);
			y+=hstep + textUnFetch.Height;

			labelResult.Location = new Point(labelLeft, labelOffh+y);
			textResult.Location = new Point(boxLeft, y);
			y+=hstep + textResult.Height;

			groupCombo.Location = new Point(grpLeft, y);

			Size gcSize = combos.Size;
			gcSize.Width+=15;
			gcSize.Height+=26;
			groupCombo.Size = gcSize;
			combos.Location = new Point(5,18);
			minHeight = y + groupCombo.Height + 5;
			ResumeLayout();
		}
	}

	/**
	 * LƂ̖Oe[uێ^u܂Ƃ߂
	 */
	class CharaNameListTabControl : Panel {
		TabControl tabs;
		SaimoeCounter scounter;
		private CharaNameListTab [] tabCharaNameLists;
		public CharaNameListTabControl(SaimoeCounter scounter, int n){
			this.scounter = scounter;
			createCharaNameListTabControl();
			// Lς烌CAEgȂ
			scounter.NumOfCharaChanged += new NumOfCharaHandler(doLayout);
			doLayout(n);
		}
		void createCharaNameListTabControl(){
			tabs = new TabControl();
			tabs.Dock = DockStyle.Fill;
			this.Controls.Add(tabs);
		}
		// n ̃^u悤ɃCAEgȂ
		// e̍XV͍sȂ
		void doLayout(int n){
			tabs.SuspendLayout();
			tabs.Controls.Clear();
			tabCharaNameLists = new CharaNameListTab[n+1];
			for(int i = 1; i <= n; i++){
				tabCharaNameLists[i] = new CharaNameListTab(scounter, i);
				tabs.Controls.Add(tabCharaNameLists[i]);
			}
			tabs.ResumeLayout();
			UpdateChNameListTab();
		}
		public void UpdateChNameListTab(){
			for(int i = 1; i < tabCharaNameLists.Length; i++){
				tabCharaNameLists[i].UpdateChNameListTab();
			}
		}
	}
	
	/***
	 * X̃Xg̃^u
	 * \̂
	 * ƂȂ...
	 */
	class ResListTab : TabPage  {
		private ListView listviewRes;
		const string RES_TABNAME           = "   Res List  ";
		SaimoeCounter scounter;
		public ResListTab(SaimoeCounter scounter){
			this.scounter = scounter;
			createResListTab();
		}
		private void createResListTab(){  // Res List Tab 쐬
			listviewRes = new ListView();
			this.SuspendLayout();

			listviewRes.View = View.Details;
			listviewRes.GridLines = true; 
			listviewRes.Columns.Clear();
			listviewRes.Columns.Add("#Thre", 80, HorizontalAlignment.Right); 
			listviewRes.Columns.Add("#Res", 40, HorizontalAlignment.Right); 
			listviewRes.Columns.Add("Date/Time", 130, HorizontalAlignment.Left);
			listviewRes.Columns.Add("Vote",160, HorizontalAlignment.Left);
			listviewRes.Columns.Add("Id", 100, HorizontalAlignment.Left);
 			listviewRes.Columns.Add("Chara", 80, HorizontalAlignment.Left);
 			listviewRes.Columns.Add("Comment", -2, HorizontalAlignment.Left); 

			
			listviewRes.Dock = DockStyle.Fill;
			this.Text = RES_TABNAME;
			this.Dock = DockStyle.Fill;
			this.Controls.Add(listviewRes);

			this.ResumeLayout(false);
		}
		// R[hXg^uAbvf[g
		public void UpdateResListTab(){
			//ListView ̃ACe쐬
			Record [] extractedRecords = scounter.ExtractedRecords;
			ListViewItem [] items = new ListViewItem[extractedRecords.Length];

			for(int i = 0; i < extractedRecords.Length; i++){
				items[i] = new ListViewItem(""+extractedRecords[i].thnum);
				items[i].SubItems.Add(""+extractedRecords[i].number);
				items[i].SubItems.Add(""+extractedRecords[i].date);
				items[i].SubItems.Add(extractedRecords[i].name);
				items[i].SubItems.Add(extractedRecords[i].code);
				items[i].SubItems.Add(scounter.getCharaName(extractedRecords[i].chara));
				items[i].SubItems.Add(extractedRecords[i].content);
			}
			// ACeǉ
			listviewRes.BeginUpdate();
			listviewRes.Items.Clear();
			listviewRes.Items.AddRange(items);
			listviewRes.EndUpdate();			
		}
	}

	/***
	 * hbOAhhbv͈₷邽߂̂
	 * {Iɂ낢ȃCxgɃnho^
	 *  Move(SHIFTftH)  Copy (CTRL)̂
	 * IDragDropControl  implement  Control 
	 * AllowEffects  DragDropEffects.All ݒ肵
	 * Control  D&DRg[ ɂ
	 * AcceptableType  typeof(󗝂f[^^) Ԃ
	 * 鑤 genDragData ł̌^̃f[^
	 * ItemDropped ŌʂmC
	 * 󂯂鑤 ItemCatch Ŏ󂯎f[^Ⴂ
	 */
	class DragDropManager {
		Rectangle dragBox;
		IDragDropControl cont; // Control
		public DragDropManager(IDragDropControl cont){
			this.cont = cont;
			dragBox = Rectangle.Empty;
			Control control = this.cont.Control;
			control.DragOver += new DragEventHandler(DragOver_Handler);
			control.DragDrop += new DragEventHandler(DragDrop_Handler);
			control.MouseDown += new System.Windows.Forms.MouseEventHandler(MouseDown_Handler);
			control.MouseUp += new MouseEventHandler(MouseUp_Handler);
			control.MouseMove += new MouseEventHandler(MouseMove_Handler);
			//control.DragEnter += new DragEventHandler(DragEnter_Handler);
			//control.DragLeave += new EventHandler(DragLeave_Handler);
			//control.GiveFeedback += new GiveFeedbackEventHandler(GiveFeedback_Handler);
			//control.QueryContinueDrag += new QueryContinueDragEventHandler(QueryContinueDrag_Handler);
		}
		private void MouseDown_Handler(object sender, MouseEventArgs e) {
			// }EXꂽChbOJnE쐬
			Size dragSize = SystemInformation.DragSize;
			dragBox = new Rectangle(new Point(e.X - (dragSize.Width /2),
											  e.Y - (dragSize.Height /2)),
									dragSize);
		}
		private void MouseUp_Handler(object sender, MouseEventArgs e) {
			// hbO͎
			dragBox = Rectangle.Empty;
		}
		private void MouseMove_Handler(object sender, MouseEventArgs e) {
			// {^
			if ((e.Button & MouseButtons.Left) == MouseButtons.Left) {
				// hbOE̊O܂ł
				if (dragBox != Rectangle.Empty && !dragBox.Contains(e.X, e.Y)) {
					object data = cont.GenDragData();
					if(data==null) return;
					DragDropEffects allowedEffects = cont.AllowedEffects;
					DragDropEffects dropEffect = cont.Control.DoDragDrop(data, allowedEffects);
					// ɗ
					if(dropEffect != DragDropEffects.None){
						cont.DragItemDropped(data, dropEffect);
					}
				}
			}
		}

		private void DragOver_Handler(object sender, System.Windows.Forms.DragEventArgs e) 
		{
				
			// Ȃ^Cvł
			if (!e.Data.GetDataPresent(cont.AcceptableType)) {
					Console.WriteLine("NotAcceptable");
				e.Effect = DragDropEffects.None;
				return;
			}
			// ̊U
			if ((e.KeyState & 4) == 4 && 
				(e.AllowedEffect & DragDropEffects.Move) == DragDropEffects.Move) {
				// SHIFT KeyState for move.
				e.Effect = DragDropEffects.Move;
			} else if ((e.KeyState & 8) == 8 && 
					   (e.AllowedEffect & DragDropEffects.Copy) == DragDropEffects.Copy) {
				// CTL KeyState for copy.
				e.Effect = DragDropEffects.Copy;
			} else if ((e.AllowedEffect & DragDropEffects.Move) == DragDropEffects.Move)  {
				// By default, the drop action should be move, if allowed.
				e.Effect = DragDropEffects.Move;
					
			} else {
				e.Effect = DragDropEffects.None;
			}
		}
		private void DragDrop_Handler(object sender, DragEventArgs e){
			// 邩H
			if (e.Data.GetDataPresent(cont.AcceptableType)) {
				object item = (object)e.Data.GetData(cont.AcceptableType);
				// ACeQbg
				cont.CatchItem(item, e);
			}
		}
		private void GiveFeedback_Handler(object sender, GiveFeedbackEventArgs e) {
				
			// ŃJ[\ύXł邪CƂ肠ftHg
			e.UseDefaultCursors = true;
		}
			
		private void QueryContinueDrag_Handler(object sender, QueryContinueDragEventArgs e) {
			// OɏoLZƂ
		}
		private void DragEnter_Handler(object sender, DragEventArgs e) {
			// 
		}
		private void DragLeave_Handler(object sender, EventArgs e) {
			// 
		}
	}
	// DragDropManager ňRg[̃bp
	interface IDragDropControl {
		// \Ȍ^
		string AcceptableType { get; }
		// D&DRg[
		Control Control{ get; }
		// 鑀
		DragDropEffects AllowedEffects{ get; }
		// ACe󂯎Ƃ
		void CatchItem(object obj, DragEventArgs e);
		// ACeɗƂ
		// data ͑f[^Ce ͌ł
		void DragItemDropped(object data, DragDropEffects e);
		// f[^
		object GenDragData();

	}
	/***
	 * ݂̓[ꂽLɑΉ閼ÕXg̃^u
	 *  NameListTabControl C
	 * Drag & Drop ŖOړ Update {^Ƃ
	 * SaimoeCounter ɎĂ閼OƃL̑Ήe[u
	 * ʂ̃OtȂǂXV
	 *
	 * XVɂ SaimoeCounter.UpdateNameList ̌ĂяosĂ
	 * ̒ UpdateNameTables Ńe[uXV
	 * UpdateNameListTabControl() ŕ\XV
	 * ۂɂ͂ tabControls ̗vfł
	 * NameListTabControl ̑Ή郁\bhĂ
	 *  tabControls[0] ̓}X^[ƂĈ
	 *  
	 */
	class NameListTab : TabPage {
		const int CONTROL_HEIGHT = 28;         // {^Ƃ̒u̍
		const string NAME_LIST_TABNAME = "  Voted Name List  "; // ^u
		private SaimoeCounter scounter;       // e SaimoeCounter
		NameListTabControl [] tabControls;    // OXg̃Rg[^u
		Button buttonNamesUpdate;             // Abvf[g{^
		Panel panel, panelTabs;               // {^Ƃƃ^ũpl
		Label labelStatus;                    // Xe[^X
		BorderLayout layout;                  // CAEg
		BoxLayout layoutTabs;                 // ^ũCAEg
		
		const int NUM_OF_CONTROLS = 2;        // Rg[^u
		
		public NameListTab(SaimoeCounter scounter){
			this.scounter = scounter;
			createNameListTab();
		}
		 // Name List Tab 쐬
		private void createNameListTab(){ 
			this.SuspendLayout();

			tabControls = new NameListTabControl[NUM_OF_CONTROLS];
			// }X^[Rg[
			tabControls[0] = new NameListTabControl(scounter);   
			tabControls[0].SelectedIndex = 0;
			// ̑
			for(int i = 1; i <tabControls.Length; i++){
				tabControls[i] = new NameListTabControl(scounter, tabControls[0]);
				tabControls[i].SelectedIndex = i;
			}
			
			
			panel = new Panel();
			panelTabs = new Panel();
			layout = new BorderLayout(CONTROL_HEIGHT, panelTabs, panel);
			labelStatus = new Label();
			//layoutTabs = new BoxLayout(false); //cɕׂ
			layoutTabs = new BoxLayout(true); // ɕׂ
			layoutTabs.Dock = DockStyle.Fill;
			layout.BorderStyle = BorderStyle.Fixed3D;
			layout.Dock = DockStyle.Fill;

			buttonNamesUpdate = new Button();
			buttonNamesUpdate.Text="Upadate Names";
			buttonNamesUpdate.Location = new Point(3,3);
			buttonNamesUpdate.Width = 100;
			panel.Controls.Add(buttonNamesUpdate);
			buttonNamesUpdate.Click += new EventHandler(UpdateNames_Click);

			for(int i = 0; i <tabControls.Length; i++){
				layoutTabs.Controls.Add(tabControls[i]);
			}
			panelTabs.Controls.Add(layoutTabs);
			
			labelStatus.Text = "";
			labelStatus.Width = 500;
			labelStatus.Location = new Point(140,8);
			panel.Controls.Add(labelStatus);

			this.Text = NAME_LIST_TABNAME;
			this.Dock = DockStyle.Fill;
			this.Controls.Add(layout);

			NameListTabControlDragDropObserver observer = new NameListTabControlDragDropObserver(DragDrop_Handler);
			for(int i = 0; i <tabControls.Length; i++){
				layoutTabs.Controls.Add(tabControls[i]);
				tabControls[i].DragDropOccured+=observer;
			}
			this.ResumeLayout(false);
		}
		// Xe[^X쐬
		string createNameListStatusString(){
// 			// Validator 
// 			SaimoeCounter.RecordValidator validator = new SaimoeCounter.RecordValidator(scounter);
// 			// ͂ɎgOe[u
// 			Hashtable [] tables = validator.Tables;
			Hashtable [] tables = scounter.getTables();
			string str = "";
			for(int i = 0; i < tables.Length; i++){
				str = str+"   " + i+":  " + scounter.getCharaName(i) +" ( "+scounter.Counts[i]+"pt )";
			}
			return str;
		}
		// Abvf[g{^̃nhDscounter.UpdateNameList Xbh
		void UpdateNames_Click(object sender, EventArgs e){
			Thread thread = new Thread(new ThreadStart(scounter.UpdateNameList));
			thread.Start();
		}
		// ׂẴRg[̕\Abvf[g
		public void UpdateNameListTabControl(){
			labelStatus.Text = createNameListStatusString();
			for(int i = 0; i <tabControls.Length; i++){
				tabControls[i].UpdateNameListTabControl();
			}
		}
		// Oe[ũAbvf[g
		public void UpdateNameTables(){
			// nameTables ̃Abvf[g̓}X^[̂
			tabControls[0].UpdateNameTables();

		}
		// q̃Rg[^uŋN D&D 𑼂̎qɓ` 
		void DragDrop_Handler(NameListTabControl src, NameListTabControl.NameListCharaDDItem dditem){
			for(int i = 0; i < tabControls.Length; i++){
				if(src==tabControls[i]) continue;
				tabControls[i].UpdateNameListByDragDrop(dditem);
			}
		}
	}
	// D&D ̘ApiNameListTabControl -> NameListTabj
	public delegate void NameListTabControlDragDropObserver(NameListTabControl src, NameListTabControl.NameListCharaDDItem dditem);

	/**
	 * [ꂽOꗗ̃Rg[^u
	 * LƂ NameListCharaTab C
	 * ꂼLɑΉ铊[ꂽO\
	 * ЂƂ}X^[w肷ƁC̓eRs[
	 * \XV UpdataNameListControl ōsC
	 * X[u̓}X^[Rs[̂Ń}X^[XVׂ
	 * UpdateNameTables Ō݂̓eɊÂ
	 * RXgN^œnꂽ SaimoeCounter ̃e[uXV
	 * e̕ύX͕̃X[u D&D ōڈړ邱
	 * ̂߂ɁCDragDropOccured Ƀnho^
	 * ̃Rg[^uɂCxgA邱
	 * (ȂƑ̂AȂȂ)
	 * {I NameListTab Ŏg
	 */
	public class NameListTabControl : TabControl {
		// XgACeĂ}X^[
		// null łȂƂ Update ̍ۂƂɂ̓eRs[
		NameListTabControl master; 
		public event NameListTabControlDragDropObserver DragDropOccured;

		// LƂ̃^u
		NameListCharaTab [] charaTabs;
		private SaimoeCounter scounter;
		NameListCharaTabDragDropObserver observer;
		
		// }X^[p̃RXgN^DSaimoCounter̃e[uXVł
		// X[uƂ D&D Ńf[^̂ł
		public NameListTabControl(SaimoeCounter scounter){
			this.master = null;
			this.scounter = scounter;
			createNameListTabControl();
		}
		// X[up̃RXgN^DMaster ̃Rs[ŁCe[uXVłȂ
		// ̃X[u}X^[ D&D Ńf[^̂ł
		public NameListTabControl(SaimoeCounter scounter, NameListTabControl master){
			this.master = master;
			this.scounter = scounter;
			createNameListTabControl();
		}
		// 쐬
		private void createNameListTabControl(){
			observer = new NameListCharaTabDragDropObserver(DragDropOccured_Hander);
			doLayout(scounter.NumButtleChara);
			scounter.NumOfCharaChanged += new NumOfCharaHandler(doLayout);
		}
		void doLayout(int n){
			SuspendLayout();
			this.Controls.Clear();
			if(charaTabs!=null){
				// Ap̃Cxgnh苎ĎE
				for(int i = 0; i < charaTabs.Length; i++){
					charaTabs[i].DragDropOccured -= observer;
					charaTabs[i].Dispose();
				}
			}
			charaTabs = new NameListCharaTab [n+1];
			// Ap̃Cxg֒ǉ
			for(int i = 0; i < charaTabs.Length; i++){
				charaTabs[i] = new NameListCharaTab(scounter, i);
				this.Controls.Add(charaTabs[i]);
				charaTabs[i].Dock = DockStyle.Fill;
				charaTabs[i].DragDropOccured += observer;
			}
			//this.Dock = DockStyle.Fill;
			ResumeLayout();
		}
		// ^u D&D NIuU[o֘AăAbvf[g
		void DragDropOccured_Hander(NameListCharaDDItem dditem){
			if(DragDropOccured!=null) DragDropOccured(this, dditem);
			UpdateNameListByDragDrop(dditem);
		}
		// D&DɂύX̃Abvf[g
		public void UpdateNameListByDragDrop(NameListCharaDDItem dditem){
			for(int i = 0; i < charaTabs.Length; i++){
				charaTabs[i].UpdateNameListByDragDrop(dditem);
			}
		}
		// }X^[ȊO̕\Abvf[g
		void UpdateNameListTabControlSlave(){
			for(int i = 0; i < charaTabs.Length; i++){
				// ꂼ}X^[̑Ή^uRs[
				ListView.ListViewItemCollection mitems = master.charaTabs[i].TheView.Items;
				ListViewItem [] items = new ListViewItem[mitems.Count];
				int idx = 0;
				foreach(ListViewItem item in mitems){
					items[idx++] = (ListViewItem)item.Clone();
				}
				ListView view = charaTabs[i].TheView;
				view.BeginUpdate();
				view.Items.Clear();
				view.Items.AddRange(items);
				view.EndUpdate();			
				charaTabs[i].Text = scounter.getCharaName(charaTabs[i].Id);
			}
		}
		// \XV
		public void UpdateNameListTabControl(){
			// CurrentNamesłĂȂƃ_łD
			if((scounter.Status & SaimoeCounterStatus.CurrentNamesGenerated)==0){
				return;
			}
			
			// }X^[ȊO̓}X^[̃Rs[
			if(master!=null) {
				UpdateNameListTabControlSlave();
				return;
			}
		  
			// Validator D
			SaimoeCounter.RecordValidator validator = new SaimoeCounter.RecordValidator(scounter);

			// ͂ɎgOe[u
			Hashtable [] tables = validator.Tables;
			Hashtable currentNames = scounter.CurrentNames;
			
			ListViewItem [] items = new ListViewItem[currentNames.Count];
			int [] cnts = new int[tables.Length];
			int [] nums = new int[items.Length];
			
			// ACeU茈De[uQƂ
			int idx = 0;
			foreach(string name in currentNames.Keys){
				int ch;
				for(ch = 1; ch < tables.Length; ch++){
					if(tables[ch].Contains(name)) break;
				}
				if(ch>=tables.Length) ch = 0;
				cnts[ch]++;
				nums[idx] = ch;
				string str = ""+(int)currentNames[name]; // [
				items[idx] = new ListViewItem("  "+SaimoeCounter.spaces[str.Length] + str);
				items[idx].SubItems.Add(name);
				idx++;
			}
			// ۂ̊UiAddRange z炸 Add ̕Hj
			ListViewItem [][] itemss = new ListViewItem[cnts.Length][];
			for(int i = 0; i < cnts.Length; i++){
				itemss[i] = new ListViewItem[cnts[i]];
				cnts[i] = 0;
			}
			for(int i = 0; i < items.Length; i++){
				itemss[nums[i]][cnts[nums[i]]++] = items[i];
			}
			for(int i = 0; i < cnts.Length; i++){
				ListView view = charaTabs[i].TheView;
				view.BeginUpdate();
				view.Items.Clear();
				view.Items.AddRange(itemss[i]);
				view.EndUpdate();			
				charaTabs[i].Text = scounter.getCharaName(charaTabs[i].Id);
			}
		}
		// SaimoeCounter ̖Oe[uXV
		public void UpdateNameTables(){
			// CurrentNamesłĂȂƃ_łD
			if((scounter.Status & SaimoeCounterStatus.CurrentNamesGenerated)==0){
				return;
			}
			
			// }X^[ȊO͍XVłȂ
			if(master!=null) return;
			// Validator D
			SaimoeCounter.RecordValidator validator = new SaimoeCounter.RecordValidator(scounter);

			// ͂ɎgOe[u
			Hashtable [] tables = validator.Tables;

			Hashtable currentNames = scounter.CurrentNames;
			// Unknown Ɉڂ̂̍폜
			foreach(ListViewItem item in charaTabs[0].TheView.Items){
				string name = item.SubItems[NameListCharaTab.NAME_COLUMN].Text;
				if(currentNames.Contains(name)){
					int chold = 0;
					for(chold = 1; chold < tables.Length; chold++){
						if(tables[chold].Contains(name)) break;
					}
					// Õe[u
					if(chold < tables.Length){
						tables[chold].Remove(name);
					}
				}
			}
			for(int ch = 1; ch < tables.Length; ch++){
				foreach(ListViewItem item in charaTabs[ch].TheView.Items){
					string name = item.SubItems[NameListCharaTab.NAME_COLUMN].Text;
					if(currentNames.Contains(name)){
						if(tables[ch].Contains(name)) continue;// O炠
						// ڂĂmF
						int chold = 0;
						for(chold = 1; chold < tables.Length; chold++){
							if(tables[chold].Contains(name)) break;
						}
						// Õe[u
						if(chold < tables.Length){
							tables[chold].Remove(name);
						}
						// e[uɃf[^
						tables[ch][name] = currentNames[name];
					}
				}
			}
			// R[h̃Abvf[g
			Record [] recs = scounter.ExtractedRecords; 
			for(int i = 0; i < recs.Length; i++){
				Record rec = recs[i];
				// `FbN
				int ch = validator.validate(rec);
				if(ch<0) continue;       // ȃGg
				//Lւ̊U
				rec.chara = ch;
				if(ch>0){
					tables[ch][rec.name] = currentNames[rec.name];
				}
			}
			scounter.MakeCounts();
		}
		// D&D őf[^CCNameListTab ւ̘Ap
		public class NameListCharaDDItem {
			int sender;               //  id
			int receiver;             // 󂯎 id
			ListViewItem [] items; // ACe
			public int Receiver {
				set {this.receiver = value;}
				get {return this.receiver;}
			}
			public int Sender {
				get {return this.sender;}
			}
			public ListViewItem [] Items {
				get {return this.items;}
			}
			// RXgN^͑ƃACew
			public NameListCharaDDItem(int sender, ListViewItem [] items){
				this.items = items;
				this.sender = sender;
			}
		}
		// D&DAp (NameListCharaTab -> NameListTabControl)
		public delegate void NameListCharaTabDragDropObserver(NameListCharaDDItem dditem);
		
		/**
		 * LƂ̓[ꂽOꗗ
		 * ̃^u D&D łdĝ݂ŁCgčڈړ
		 * D&D 邽߂ɂ DragDropOccured Ƀnho^āC
		 * Ǝ󂯎 UpdateNameListByDragDrop œ`ׂ
		 * (P̂łD&Ďʔf͂Ȃ̂)
		 */
		class NameListCharaTab : TabPage, IDragDropControl {
			public const int NAME_COLUMN = 1;  // O̗ԍ(0 or 1)
			public const int COUNT_COLUMN = 0; // JEg̗ԍ(0 or 1)
			// xɂȂɂȂ 28 xɂăxɕw
			const int CONTROL_HEIGHT = 0; 
			private ListView listview;
			private Panel controlPanel;
			private	BorderLayout layout;
			private Label statusLabel;
			private SaimoeCounter scounter;
			int id; // 0  (0 UnKnown)
			public int Id {
				get {return this.id;}
			}

			public event NameListCharaTabDragDropObserver DragDropOccured;
			DragDropManager ddmanager; // D&D p

 			// \Ȍ^
			public string AcceptableType { get {return (typeof(NameListCharaDDItem)).ToString();} }
			// D&DRg[
			public Control Control{ get {return listview;} }
			// 鑀
			public DragDropEffects AllowedEffects{ get{ return DragDropEffects.All;} }
			// ACe󂯎Ƃ
			public void CatchItem(object obj, DragEventArgs e){
				NameListCharaDDItem dditem = obj as NameListCharaDDItem;
				if(dditem == null) return;
				if((e.Effect & DragDropEffects.Move) == DragDropEffects.Move
				   || (e.Effect & DragDropEffects.Copy) == DragDropEffects.Copy){
					// Ƃ̒ʐM͉Ȃ
					if(dditem.Sender==this.id) return;
					dditem.Receiver = this.id;  // 󂯎o^
					// Abvf[gA
					if(DragDropOccured!=null) DragDropOccured(dditem);
				}		
			}
			// ACeɗƂ
			public void DragItemDropped(object data, DragDropEffects e){
				// ɉȂDeƂɓ`ăAbvf[g
			}
			// f[^iI𒆂̃ACepbNj
			public object GenDragData(){
				ListViewItem [] items = new ListViewItem[listview.SelectedItems.Count];
				int idx = 0;
				foreach(ListViewItem item in listview.SelectedItems){
					items[idx++] = item;
				}
				return new NameListCharaDDItem(this.id, items);
			}
			
			public ListView TheView {
				get {return this.listview;}
			}
			// D&D ł̍XVDeĂяoׂD
			public void UpdateNameListByDragDrop(NameListCharaDDItem dditem){
				if(dditem.Sender == this.id){ // ɑΉ
					//
					ListViewItem [] items = dditem.Items;
					listview.BeginUpdate();
					// 					for(int i = 0; i < items.Length; i++){
					// 						listview.Items.Remove(items[i]);
					// 					}
					// ꕶ̏ꍇłꎋĂȂ̂
					// 蓮ŌĎE O(nlogn+mlogm) 
					// ܂C\[gȂĂd for ŏ\...
					// ƁCvCArray.Sort  QuickSortȂĎgĂ₪.
					// O(n^2)D}[W\[gɏȂ
					ListViewItem [] vitems = new ListViewItem[listview.Items.Count];
					int idx = 0;
					foreach(ListViewItem item in listview.Items){
						vitems[idx++] = item;
					}
					ItemComparer comp = new ItemComparer();
					Array.Sort(vitems, comp);
					Array.Sort(items, comp);
					int i = 0;
					int j = 0;
					for(;;){
						int c = comp.Compare(vitems[i], items[j]);
						if(c==0){
							listview.Items.Remove(vitems[i]);
							i++; j++;
						} else if (c < 0) {
							i++;
						} else { // c > 0
							j++;
						}
						if(i>=vitems.Length || j>=items.Length) break;
					}
					listview.EndUpdate();
				} else if (dditem.Receiver == this.id){  // 󂯂đ
					//
					ListViewItem [] items = dditem.Items;
					listview.BeginUpdate();
					for(int i = 0; i < items.Length; i++){
						// Clone() ĂȂƂЂƂ̃ACe
						// ViewŎgƂɂȂĂD
						// G[o͂ƂȂ
						// Ԃ͂܂
						listview.Items.Add((ListViewItem)items[i].Clone());
					}
					listview.EndUpdate();
				}
			}
			// RXgN^DԖڂ̃LɑΉ邩 id
			public NameListCharaTab(SaimoeCounter scounter, int id){
				this.scounter = scounter;
				this.id = id;
				createNameListCharaTab();
				ddmanager = new DragDropManager(this);
			}
			// 쐬
			private void createNameListCharaTab(){
				listview = new ListView();
				this.SuspendLayout();
				controlPanel = new Panel();
				layout = new BorderLayout(CONTROL_HEIGHT, listview, controlPanel);
				statusLabel = new Label();
			
				statusLabel.Text = "";
				statusLabel.Width = 200;
				statusLabel.Location = new Point(140,8);
				controlPanel.Controls.Add(statusLabel);

				listview.View = View.Details;
				listview.GridLines = true; 
				listview.AllowColumnReorder = true;
				listview.Columns.Clear();

				
				//{͖Oɂ, \ŗւƗǂ̂...
				listview.Columns.Add("Count", 60, HorizontalAlignment.Center); 
				listview.Columns.Add("Name", -2, HorizontalAlignment.Left);
				listview.FullRowSelect = true;
				listview.ListViewItemSorter = new NameListCharaItemComparer();
				
				listview.AllowDrop = true;
				listview.MultiSelect = true;
				layout.Dock = DockStyle.Fill;
				layout.BorderStyle = BorderStyle.Fixed3D;
				this.Text = scounter.getCharaName(id);
				this.Dock = DockStyle.Fill;
				this.Controls.Add(layout);
				
				this.ResumeLayout(false);
				this.SizeChanged += new EventHandler(SizeChanged_Handler);
			}
			// TCỸ^C~OɂčőOʂ̃^uɂȂ,
			// Width  -2 ݒ肵̃TCY\̃TCY炸邽,
			// IɃTCY낦Ă`
			void SizeChanged_Handler(object src, EventArgs e){
				listview.Columns[NAME_COLUMN].Width = -2;
			}
			// Xe[^X쐬
			string createNameListStatusString(){
				return scounter.getCharaName(id) +" -- "+scounter.Counts[id]+" point";
			}
			// vf̔rD[݂̂r
			class ItemComparer : IComparer {
				public int Compare(object x, object y){
					ListViewItem xi = x as ListViewItem;
					ListViewItem yi = y as ListViewItem;
					//if(xi==null || yi==null) return 0;
					int col = NAME_COLUMN;
					return String.Compare(xi.SubItems[col].Text, yi.SubItems[col].Text);
				}
			}
			// LpOXg̃\[gpr([CO)
			class NameListCharaItemComparer : IComparer {
				public NameListCharaItemComparer() {
				}
				public int Compare(object x, object y) {
					ListViewItem ix = (ListViewItem)x;
					ListViewItem iy = (ListViewItem)y;
					
					// 
					int col = COUNT_COLUMN;
					int c = -String.Compare(ix.SubItems[col].Text, iy.SubItems[col].Text);
					if(c!=0) return c;
					// O
					col=NAME_COLUMN;
					return String.Compare(ix.SubItems[col].Text, iy.SubItems[col].Text);
				}
			}
		}
	}

	/**
	 * Chara Name Tab
	 * id Ԗڂ̃LɑΉ閼Oe[u\
	 * {̓e[u̕ҏW@\ׂ...
	 * `FbNvf@\͂ĂȂi{^͂邯ǁj
	 */ 
	class CharaNameListTab : TabPage{
		const int CONTROL_HEIGHT = 28;         // {[_[̖k̂Ƃ̍
		private ListView listviewChNames;      // Oꗗ View
		private Panel panelChNameListControl;  // {^Ƃ̃pl
		private	BorderLayout layoutChNameList; // CAEg
		private Button buttonDelChNames;       // {^
		private Label labelChNameListStatus;   // ԕ\
		private SaimoeCounter scounter;
		
		int id; // 1 
		public CharaNameListTab(SaimoeCounter scounter, int id){
			this.scounter = scounter;
			this.id = id;
			createChNameListTab();
			
		}

		// 쐬
		private void createChNameListTab(){
			listviewChNames = new ListView();
			this.SuspendLayout();
			panelChNameListControl = new Panel();
			layoutChNameList = new BorderLayout(CONTROL_HEIGHT, listviewChNames, panelChNameListControl);
			buttonDelChNames = new Button();

			labelChNameListStatus = new Label();
			

			buttonDelChNames.Text="Delete Checked Names";
			buttonDelChNames.Location = new Point(3,3);
			buttonDelChNames.Width = 100;
			panelChNameListControl.Controls.Add(buttonDelChNames);

			labelChNameListStatus.Text = "";
			labelChNameListStatus.Width = 200;
			labelChNameListStatus.Location = new Point(140,8);
			panelChNameListControl.Controls.Add(labelChNameListStatus);

			listviewChNames.View = View.Details;
			listviewChNames.GridLines = true; 
			listviewChNames.Columns.Clear();
			listviewChNames.Columns.Add("Count", 70, HorizontalAlignment.Center);
			listviewChNames.Columns.Add("Name", -2, HorizontalAlignment.Left); 

			listviewChNames.BorderStyle = BorderStyle.Fixed3D;
			listviewChNames.CheckBoxes = true;
			listviewChNames.FullRowSelect = true;
			listviewChNames.ListViewItemSorter = new ChNameListItemComparer();
			
			layoutChNameList.Dock = DockStyle.Fill;
			layoutChNameList.BorderStyle = BorderStyle.Fixed3D;
			this.Text = scounter.getCharaName(this.id);
			this.Dock = DockStyle.Fill;
			this.Controls.Add(layoutChNameList);

			this.ResumeLayout(false);
			this.SizeChanged += new EventHandler(SizeChanged_Handler);
			scounter.SelectCharaChanged += new SelectCharaHandler(SelectChara_Handler);
		}
		// LIςāC̒SȂXV
		void SelectChara_Handler(string chara, int num){
			if(num==id) UpdateChNameListTab();
		}
		// TCỸ^C~OɂčőOʂ̃^uɂȂ,
		// Width  -2 ݒ肵̃TCY\̃TCY炸邽,
		// IɃTCY낦Ă`
		void SizeChanged_Handler(object src, EventArgs e){
			listviewChNames.Columns[1].Width = -2;
		}
		// Names ̍폜(͂Ȃ)
		void DeleteNames_Click(object sender, EventArgs e){
		}
		// ԕ񐶐
		string createNameListStatusString(){
			//scounter.MakeCounts();
			return scounter.getCharaName(id) +" -- "+scounter.Counts[id]+" point";
		}
		//L̖OXg̍XV
		public void UpdateChNameListTab(){
			// e[uƂĂ
			SaimoeCounter.RecordValidator validator = new SaimoeCounter.RecordValidator(scounter);
			Hashtable table = validator.Tables[id];
			if(table==null) {
				listviewChNames.BeginUpdate();
				listviewChNames.Items.Clear();
				listviewChNames.EndUpdate();
				return;
			}
			ListViewItem [] items = new ListViewItem[table.Count];
			// ACeǉ
			int idx = 0;
			foreach(string name in table.Keys){
				string str = ""+(int)table[name];
				items[idx] = new ListViewItem(" "+SaimoeCounter.spaces[str.Length] + str);
				items[idx].SubItems.Add(name);
				idx++;
			}
			listviewChNames.BeginUpdate();
			listviewChNames.Items.Clear();
			listviewChNames.Items.AddRange(items);
			listviewChNames.EndUpdate();
			labelChNameListStatus.Text = createNameListStatusString();
			this.Text = scounter.getCharaName(this.id);
		}
		// LpOXg̃\[gpr
		class ChNameListItemComparer : IComparer {
			public ChNameListItemComparer() {
			}
			public int Compare(object x, object y) {
				ListViewItem ix = (ListViewItem)x;
				ListViewItem iy = (ListViewItem)y;

				int col = 0;
				//  iE񂹕j
				int c = -String.Compare(ix.SubItems[col].Text, iy.SubItems[col].Text);
				if(c!=0) return c;
				col++;
				//  O
				return String.Compare(ix.SubItems[col].Text, iy.SubItems[col].Text);
			}
		}
	}

	/***
	 * Graph Tab
	 * Ot\̂
	 * Œ`Ă GraphDrawer Ƃg
	 * TCY͌Œ肾Cł{^ƂΊȒPɂłD
	 * 肩́CقTCY Bitmap āC
	 * pictureGraph  Image ɕύX
	 * graph ɑ΂ĐV Bitmap  Graphics năTCYw肷D
	 */ 
	class GraphTab : TabPage {
		// ftHg̐FD(Lԍ % F) ̐Fg
		Color [] defaultColors = {Color.Black, Color.Red, Color.Blue, Color.Green};
		const string GRAPH_TABNAME         = "    Graph    ";
		private PictureBox pictureGraph;       // Ot\ꏊ
		private Bitmap imageGraph;             // OtC[W
		private Panel panelGraphControl;       // Rg[p
		private Button buttonGraphDraw;        // ĕ`H
		private TextBox textYMax;              // yől
		private Label labelYMax;
		private GraphDrawer graph;
		private SaimoeCounter scounter;
		private Panel panel;
		int ymax;
		public GraphTab(SaimoeCounter scounter){
			this.scounter = scounter;
			ymax = 800;
			createGraphTab();
		}
		private void createGraphTab(){  // Graph Tab 쐬
			// CX^X
			panelGraphControl = new Panel();
			buttonGraphDraw = new Button();
			pictureGraph = new PictureBox();
			imageGraph = new Bitmap(640, 480);
			textYMax = new TextBox();
			labelYMax = new Label();
			panel = new Panel();
			this.SuspendLayout();          // Layout ֌W̃Cxg~

			// eLXgݒƂReiւ̒ǉ
			textYMax.Text = ""+ymax;
			labelYMax.Text = "y-max";
			pictureGraph.Image = imageGraph;
			pictureGraph.BorderStyle = BorderStyle.Fixed3D;  // {[_[
			buttonGraphDraw.Text = "Draw Graph";
			panelGraphControl.Controls.Add(labelYMax);
			panelGraphControl.Controls.Add(textYMax);
			panelGraphControl.Controls.Add(buttonGraphDraw);

			//{^Cxgǉ
			buttonGraphDraw.Click += new EventHandler(DrawGraph_Click);

			panel.Controls.Add(panelGraphControl);
			panel.Controls.Add(pictureGraph);
			
			// Rg[̃TCYςnhĂԂ悤ɐݒ
			panel.SizeChanged += new EventHandler(PanelGraphLayout_Handler);

			panel.Dock = DockStyle.Fill;
			this.Text = GRAPH_TABNAME;
			this.Dock = DockStyle.Fill;   // eReihԂ悤
			this.Controls.Add(panel);

			this.ResumeLayout(false);       // Layout ֌W̃CxgĊJ

			initGraph();
			
		}
		void DrawGraph_Click(object src, EventArgs e){
			int yy = ymax;
			try{
				yy = int.Parse(textYMax.Text.Trim());
			} catch(Exception ex){
				Console.WriteLine(ex.Message);
				yy = ymax;
			}
			if(yy!=ymax){
				ymax = yy;
				initGraph();
			}
			drawGraph();
		}
		void setYtics(int ym){
			int mm, hmm, sub;
			if(ym < 10){
				mm = ym;
				hmm = mm/2;
				sub = 1;
			} else {
				int k = ym, l = 0;
				for(;k > 0; k/=10, l++);
				l-=2;
				for(k = 1; l > 0; k*=10, l--);
				mm = (ym / k) * k;
				hmm = mm / 2;
				sub = hmm / 5;
			}
			string [] ytics = {"0", ""+hmm, ""+mm};
			int [] ypos = {0, hmm, mm};
			graph.setYtics(ytics, ypos);
			graph.YSubTicsStep = sub;
			graph.Yrange = new GraphRange(0, ym);
		}
		// OtD`̓o^ tics ̐ݒȂ
		public void initGraph(){
			graph = new GraphDrawer();
			graph.Graphics = Graphics.FromImage(imageGraph);
			graph.Size = imageGraph.Size;
			graph.Xrange = new GraphRange(0, 23*60*60+10*60);
			string [] xtics = {"00:00", "03:00", "06:00", "09:00", "12:00", "15:00", "18:00", "21:00"};
			int [] xpos = new int[xtics.Length];
			setYtics(ymax);
			int x = 0;
			int dx = 3*60*60;
			for(int i = 0; i < xpos.Length; i++){
				xpos[i] = x;
				x+=dx;
			}
			graph.setXtics(xtics, xpos);
			graph.XSubTicsStep = 3600;
			graph.PointSize = 1.3;
			graph.BoxWidth = 0.3;
		}
		// Ot`
		public void drawGraph(){
			// Validator ăe[u擾
			SaimoeCounter.RecordValidator validator = new SaimoeCounter.RecordValidator(scounter);
			Hashtable [] tables = validator.Tables;

			// JEgłĂȂƃ_łD
			if((scounter.Status & SaimoeCounterStatus.CountsGenerated)==0){
				return;
			}
			
			// f[^L^p̗̈m
			int [] cnts = new int[tables.Length];
			Point [][] ps = new Point[cnts.Length][];
			for(int i = 1; i < cnts.Length; i++){
				cnts[i] = 0;
				ps[i] = new Point[scounter.Counts[i]];
			}
			double ratio = 0.9/cnts.Length;
			graph.BoxWidth = ratio*0.9;      // Box ̕ݒ

			// ԂƂ̓vp
			int [][] hcnts = new int[cnts.Length][];
			for(int i = 1; i < hcnts.Length; i++){
				hcnts[i] = new int[24];
				for(int j = 0; j < 24; j++){
					hcnts[i][j] = 0;
				}
			}
			// f[^
			for(int i = 0; i < scounter.ExtractedRecords.Length; i++){
				Record rec = scounter.ExtractedRecords[i];
				// 
				int ch = validator.validate(rec);
				if(ch<=0) continue;       // ֌WȂR[h

				int h = rec.date.Hour;
				int m = rec.date.Minute;
				int s = rec.date.Second;
				ps[ch][cnts[ch]]=new Point(((h*60)+m)*60+s, cnts[ch]+1);
				//Console.Write(ps[ch][cnts[ch]]);
				cnts[ch]++;
				hcnts[ch][h]++;
			}
			// Ot`pf[^
			GraphItem [] gs = new GraphItem[(cnts.Length-1)*2];
			for(int i = 1; i < cnts.Length; i++){
				GraphItem g1 = new GraphItem();
				GraphItem g2 = new GraphItem();
				g1.Style = GraphItemStyle.Lines;
				g2.Style = GraphItemStyle.Box;
				g1.Color = defaultColors[i%defaultColors.Length];
				g2.Color = defaultColors[i%defaultColors.Length];
				g1.Points = ps[i];
				int dif = (int)(i*3600*ratio);
				Point [] hps = new Point[23];
				for(int j = 0; j < 22; j++){
					hps[j] = new Point(j*3600+dif, hcnts[i][j]);
				}
				hps[22] = new Point(22*3600+dif, hcnts[i][22] + hcnts[i][23]);
				
				g2.Points = hps;

				g1.Title = scounter.getCharaName(i);
				gs[i-1] = g1;
				gs[i+cnts.Length-2] = g2;
			}
			// ͕`̂
			graph.Plot(gs);
			//ʒm
			pictureGraph.Refresh();
		}

		// GraphTab ̃CAEg
		private void PanelGraphLayout_Handler(object sender, EventArgs e){

			Size cs = this.ClientSize;
			int controlWidth = 100;
			panelGraphControl.Size = new Size(controlWidth, cs.Height);
			Size csp = panelGraphControl.ClientSize;
			int hmargin = 5;
			int vmargin = 10;
			int sep = 5;
			int lw = 40;
			int tw = csp.Width - hmargin*2 - lw;
			int lleft = hmargin;
			int tleft = lleft + lw;
			int bleft = lleft;
			int top = vmargin;
			int h = 22;
			int bw = csp.Width - hmargin*2;

			labelYMax.Size = new Size(lw, h);
			textYMax.Size = new Size(tw, h);	
			buttonGraphDraw.Size = new Size(bw, h);

			int y = top;
			labelYMax.Location = new Point(lleft ,y+2);
			textYMax.Location = new Point(tleft,y);
			y+=sep + h;
			buttonGraphDraw.Location = new Point(bleft, y);

			pictureGraph.Size = new Size(cs.Width - controlWidth, cs.Height);
			pictureGraph.Location = new Point(controlWidth, 0);

			// image ̃TCYύXōl悤D
			// AXyNgŒōő剻Ƃ
			// {^ŕύXƂ
		}

	}



	/**
	 * k邾̃{[_[CAEgH
	 * k̍RXgN^Ŏw肷D
	 * ɁCkƒɔzupl킽ׂD
	 */
	class BorderLayout : Panel {
		Control center;
		Control north;
		int height;
		public BorderLayout(int height, Control c, Control n){
			this.SizeChanged += new EventHandler(SizeChanged_Handler);
			this.height = height;
			center = c;
			north = n;
			this.Controls.Add(north);
			this.Controls.Add(center);
		}
		
		void SizeChanged_Handler(object sender, EventArgs e){
			Size cs = ClientSize;
			// Rg[̈ʒuƃTCYw
			north.Location = new System.Drawing.Point(0, 0);
			center.Location = new Point(0, height);	
			north.Size = new Size(cs.Width, height);
			center.Size = new Size(cs.Width, cs.Height-height);
		}
	}
	// cɋϓɃRg[zuBoxLayout
	// RXgN^̈ true ŉ
	class BoxLayout : Panel {
		bool horizontal;
		public BoxLayout(bool horizontal){
			this.SizeChanged += new EventHandler(SizeChanged_Handler);
			this.horizontal = horizontal;
		}
		void SizeChanged_Handler(object sender, EventArgs e){
			Size cs = ClientSize; // NCAg̈
			int n = Controls.Count; // q̐
			if(n==0) return;

			int dx, dy;
			Size size;
			if(horizontal){        // 
				dx = cs.Width / n;
				dy = 0;
				size = new Size(dx, cs.Height);
			} else {
				dx = 0;
				dy = cs.Height / n;
				size = new Size(cs.Width, dy);
			}	
			// ʒuƃTCYw
			int x = 0;
			int y = 0;
			for(int i = 0; i < n; i++){
				Controls[i].Location = new Point(x, y);
				Controls[i].Size = size;
				x+=dx;
				y+=dy;
			}
		}
	}


	// sǂݍ݃_CAO
	class TextBoxDialog : Form {
		TextBox text;
		Button button;
		string str;
		string mes;
		int len;
		public TextBoxDialog(string title){
			this.Text = title;
			mes = null;
			len = 200;
			initialize();
		}
		// eLXg{bNX̉ƃbZ[Ww
		public TextBoxDialog(string title, string message, int w){
			this.Text = title;
			mes = message;
			len = w;
			initialize();
		}
		// ΂Ĕzu
		void initialize(){
			text = new TextBox();
			button = new Button();
			button.Text = "OK";
			int top = 2;
			int h = 20;
			int w = 2;
			int tmph = 80;
			int tmpw = 600;
			int textw  = len;
			int buttonw  = 40;
			int leftbutton = textw + w;
			int contentw = leftbutton + w + buttonw;
			int contenth = h + top * 2;

			if(mes!=null){
				Label label = new Label();
				label.Text = mes;
				label.Height = h;
				label.Width = buttonw + textw + w;
				label.Location = new Point(w, top+4);
				this.Controls.Add(label);
				top+= + h + 2;
				contenth += h;
			}
			button.Height = h;
			button.Width = buttonw;
			button.Top = top;
			text.Height = h;
			text.Width = textw;
			text.Top = top;
			text.Location = new Point(w, top);
			button.Location = new Point(leftbutton, top);
			Size = new Size(tmpw , tmph);
				
			Size cs = ClientSize;
			Size = new Size(tmpw - (cs.Width-contentw), tmph - (cs.Height-contenth));
				
			Controls.Add(text);
			Controls.Add(button);
			button.Click += new EventHandler(OK_Click); // OK{^ߑ
			this.SizeGripStyle = SizeGripStyle.Hide;
			// Enter L[
			text.KeyPress += new KeyPressEventHandler(KeyPress_Handler);
		}
		// L[͂⑫. ENter L[ȂI
		void KeyPress_Handler(object src, KeyPressEventArgs e){
			if(e.KeyChar == (char)0x0d) {
				e.Handled = true;
				str = text.Text;
				this.Close();
			}
		}
		void OK_Click(object sender, EventArgs e){
			str = text.Text;
			this.Close();
		}
		// _CAOoĕ擾
		public string inputText(){
			str = null;
			ShowDialog();
			return str;
		}
	}
	// X HTML 𕶎Ƃē͂ƁCKɕ Record ̔zԂ
	// [𕡐󂯕tꍇɂ́CRecord ̕zɂāC
	// ͂Ă镔SRecord ɓn悤ɂD
	class HTMLAnalyzer {
		public static Record [] analyze(string contentString, int thnum){
			// ]vȕȂ
			int idxt = contentString.IndexOf("<!-- Asin:");
			int idxi = contentString.IndexOf("<dt>");
			idxi+=4;
			contentString = contentString.Substring(idxi, idxt-idxi);
			// R[hɕ邽߂̐K\
			Regex rs = new Regex("<dt>");
			Regex resnum = new Regex("<a[^>]*>([0-9]+)</a>");
			Regex rescon = new Regex("<dd>(.*)");
			Regex datetime = new Regex("(20[0-9][0-9])/([01][0-9])/([0123][0-9])[^:]*([0-2][0-9]):([0-5][0-9]):([0-5][0-9])");
			Regex resname = new Regex("&lt;&lt;([^&]*)&gt;&gt;");
			Regex resid = new Regex("\\[\\[([^\\]]*)\\]\\]");

			// sE
			contentString = contentString.Replace("\n", "");
			// R[hPʂ̕ɐ؂
			string [] recs = rs.Split(contentString);
			Record [] records = new Record[recs.Length];
			// R[h쐬
			for(int i = 0; i < recs.Length; i++){
				//Console.WriteLine(i + " " + recs[i]);
				Match m;

				// K\Ƀ}b`Ĉڂ̃O[voiōj
				m = resnum.Match(recs[i]);
				int number = int.Parse(m.Groups[1].Value);;
				m = rescon.Match(recs[i]);
				string content = m.Groups[1].Value;
				// t͊eO[v 
				m = datetime.Match(recs[i]);
				DateTime date;
				if(m.Success){ // }b`o
					int yy = int.Parse(m.Groups[1].Value);
					int mm = int.Parse(m.Groups[2].Value);
					int dd = int.Parse(m.Groups[3].Value);
					int hh = int.Parse(m.Groups[4].Value);
					int min = int.Parse(m.Groups[5].Value);
					int ss = int.Parse(m.Groups[6].Value);
					date = new DateTime(yy, mm, dd, hh, min, ss, 0);
				} else {
					date = new DateTime(1,1,1,0,0,0,0);
				}
				string name = "";
				string code = "";
				MatchCollection mc;
				// }b`ČmFDȂ荞
				mc = resname.Matches(recs[i]);
				if(mc.Count==1) {
					name = mc[0].Groups[1].Value;
				}
				mc = resid.Matches(recs[i]);
				if(mc.Count==1) {
					code = mc[0].Groups[1].Value;
				}
				records[i] = new Record(thnum, number, content, date, code, name);
				//Console.WriteLine(records[i]);
			
			}
			//Console.Write("#res = " + recs.Length);
			return records;
		}
	}
	// R[h
	public class Record {
		public string content;  // ݓe
		public string name;     // [
		public string code;     // R[h
		public int number;      // Xԍ
		public int thnum;       // Xԍ
		public DateTime date;   // X
		public int chara;       // ǂLH
		public Record(int thnum, int number, string content, DateTime date, string code, string name){
			this.thnum = thnum;
			this.content = content;
			this.number = number;
			this.date = date;
			this.code = code;
			this.name = name;
			chara = 0; // s
		}
		// \p
		public override string ToString() {
			return
				"thnum= " + thnum + "\n"
				+ "number= " + number + "\n"
				+ "date= " + date + "\n"
				+ "content= " + content + "\n"
				+ "code= " + code + "\n"
				+ "name= " + name + "\n";
		}
	}
	// r
	class RecordComparator : IComparer {
		public RecordComparator(){
		}
		// ԂŔr
		public int Compare(object x, object y) {
			Record rx = (Record)x;
			Record ry = (Record)y;
			return DateTime.Compare(rx.date, ry.date);
			//int c = rx.thnum - ry.thnum;
			//if(c!=0) return c;
			//return rx.number - ry.number;
		}
		
	}
	/***
	 * MԂm炳nh
	 * url URL
	 * length ͎M
	 * done ͏Iǂ
	 * id ̓RXgN^ɓnꂽ int
	 **/
	public delegate void ReadHTMLEventHandler(string url, int length, bool done, int id);
	/**
	 * HTML 񓯊ɂƂĂD
	 */
	class HTMLGetter {
		// MԂ̃nh
		public event ReadHTMLEventHandler OnReadProgress;
		// M wait p
		public ManualResetEvent allDone= new ManualResetEvent(false);
		public ManualResetEvent allDone2= new ManualResetEvent(false);
		// ԕێpNX
		public class RequestState{
			const int INIT_BUFFER_SIZE = 64*1024; // ŏ̃obt@TCY
			public const int READ_STEP = 4*1024;  // ǂݍ݃Xebv
			public int len;                       // f[^
			public byte[] buf;                    // obt@
			public WebRequest req;                // WebNGXg
			public WebResponse res;               // X|X
			public Stream resStream;
			public RequestState(){
				len = 0;
				buf = new byte[INIT_BUFFER_SIZE];
				req = null;
				resStream = null;
			}
			public void extendBuffer(){
				byte [] nbuf = new byte[buf.Length*2];
				// len ܂ł̃Rs[
				Array.Copy(buf, nbuf, len);
				buf = nbuf;
			}
		}
		// X|X擾̃R[obN
		private void RespCallback(IAsyncResult asynchronousResult){  
			// Ԃ擾
			RequestState state=(RequestState) asynchronousResult.AsyncState;
			WebRequest req=state.req;
			// X|X擾
			state.res =  req.EndGetResponse(asynchronousResult);
			// Xg[擾
			Stream resStream = state.res.GetResponseStream();
			state.resStream=resStream;
			// 񓯊ŃXg[ǂݍ
			IAsyncResult asynchronousResultRead = resStream.BeginRead(state.buf, state.len, RequestState.READ_STEP, new AsyncCallback(ReadCallBack), state);
		}
		private void ReadCallBack(IAsyncResult asyncResult) {
			// Ԏ擾
			RequestState state = (RequestState)asyncResult.AsyncState;
			Stream resStream = state.resStream;
			int read = resStream.EndRead( asyncResult );
			// Xg[ǂݍ
			if (read > 0) {
				// obt@GNXeh
				state.len+=read;
				if(state.buf.Length - state.len < RequestState.READ_STEP) state.extendBuffer();
				// nhɘA
				if(OnReadProgress!=null) OnReadProgress(url, state.len, false, this.id);
				// ̓ǂݍ݂o^
				IAsyncResult asynchronousResult = resStream.BeginRead(state.buf, state.len, RequestState.READ_STEP, new AsyncCallback(ReadCallBack), state);
			} else {
				// ǂݍݏI
				resStream.Close();
				// nhɘA
				if(OnReadProgress!=null) OnReadProgress(url, state.len, true, this.id);
				allDone.Set();
			}
		}
		void run(){
			WebRequest req = (HttpWebRequest)WebRequest.Create(url);
			// Ԃ
			RequestState state = new RequestState();
			state.req = req;
			// 񓯊ɏ擾
			IAsyncResult ares =(IAsyncResult)req.BeginGetResponse(new AsyncCallback(RespCallback), state);
			// M̏I҂ĂD
			allDone.WaitOne();
			// ĊJ
			state.res.Close();

			ret = new byte[state.len];
			Array.Copy(state.buf, ret, ret.Length);
			allDone2.Set();
		}
		// HTMLƂĂij
		public void FetchHTML(string url){
			this.url = url;
			run();
		}
		// HTMLƂĂi񓯊j
		public void BeginFetchHTML(string url){
			this.url = url;
			this.thread = new Thread(new ThreadStart(this.run));
			this.thread.Start();
		}
		// I҂ɂȂ
		public void EndFetchHTML(){
			allDone2.WaitOne();
		}
		public HTMLGetter(int id){
			this.id = id;
			ret = null;
		}
		public byte [] ret;   // ʂĂƂ
		private Thread thread; // MŜ̃Xbh
		private String url;    // ɍs url
		private int id;        // Cxgœn id ł
	}

	
}
